package com.maverick.multiplex;

import java.io.IOException;

import com.maverick.util.ByteArrayWriter;

public class Request {

	byte[] requestData;
	String requestName;
	
    public Request(String requestName) {
        this(requestName, (byte[]) null);
    }
    
	public Request(String requestName, byte[] requestData) {
		this.requestName = requestName;
		this.requestData = requestData;
	}
    
    public Request(String requestName, Object[] values) throws IOException {
        this.requestName = requestName;
        ByteArrayWriter writer = new ByteArrayWriter();
        for (int index = 0; index < values.length; index++) {
            writer.writeString(values[index].toString());            
        }
        requestData = writer.toByteArray();
    }
	
	public String getRequestName() {
		return requestName;
	}
	
	public byte[] getRequestData() {
		return requestData;
	}
	
	public void setRequestData(byte[] requestData) {
		this.requestData = requestData;
	}
}