/*
 *  SSL-Explorer
 *
 *  Copyright (C) 2003-2006 3SP LTD. All Rights Reserved
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
			
package com.sslexplorer.applications.server;

import java.io.IOException;

import com.sslexplorer.boot.XMLElement;

/**
 * @author Sebastien Belin <a href="mailto: seb@3sp.com">&lt;seb@3sp.com&gt;</a>
 * 
 */
public interface ApplicationServerType {
    public void prepare(ServerLauncher launcher, ServerLauncherEvents events, XMLElement element) throws IOException;

    public void start();

    public boolean checkFileCondition(XMLElement el) throws IOException, IllegalArgumentException;

    public ProcessMonitor getProcessMonitor();

    public String getRedirectParameters();

    public String exitMessage = "";

}
