/*
 *  SSL-Explorer
 *
 *  Copyright (C) 2003-2006 3SP LTD. All Rights Reserved
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
			
package com.sslexplorer.webforwards.webforwardwizard.forms;

import javax.servlet.http.HttpServletRequest;

import org.apache.struts.Globals;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.ActionMessage;

import com.sslexplorer.webforwards.WebForward;
import com.sslexplorer.wizard.AbstractWizardSequence;
import com.sslexplorer.wizard.forms.DefaultWizardForm;

/**
 */
public class WebForwardTypeSelectionForm extends DefaultWizardForm {
    private static final int NO_TYPE_SELECTED = -1; 
    public static final String ATTR_TYPE = "type";
    private int type = WebForward.TYPE_TUNNELED_SITE;

    /**
     * Construtor
     */
    public WebForwardTypeSelectionForm() {
        super(true, false, "/WEB-INF/jsp/content/webforward/webforwardwizard/webForwardTypeSelection.jspf", "", false, false,
                        "webForwardTypeSelection", "webForwards", "webForwardWizard.webForwardTypeSelection", 1);
    }
        
    /* (non-Javadoc)
     * @see com.sslexplorer.wizard.forms.AbstractWizardForm#apply(com.sslexplorer.wizard.AbstractWizardSequence)
     */
    public void apply(AbstractWizardSequence sequence) throws Exception {
        super.apply(sequence);
        sequence.putAttribute(ATTR_TYPE, new Integer(type));
    }

    /**
     * @return int
     */
    public int getType() {
        return type;
    }

    /**
     * @param type
     */
    public void setType(int type) {
        this.type = type;
    }

    @Override
    public ActionErrors validate(ActionMapping mapping, HttpServletRequest request) {
        if(isCommiting() && type == NO_TYPE_SELECTED) {
            ActionErrors errors = new ActionErrors();
            errors.add(Globals.ERROR_KEY, new ActionMessage("webForwardWizard.webForwardTypeSelection.error.noSelection"));
            return errors;
        }
        return null;
    }
}