/*
 *  SSL-Explorer
 *
 *  Copyright (C) 2003-2006 3SP LTD. All Rights Reserved
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
			
package com.sslexplorer.input.validators;

import java.util.List;
import java.util.Properties;

import com.sslexplorer.boot.CodedException;
import com.sslexplorer.boot.PropertyDefinition;
import com.sslexplorer.boot.PropertyValidator;
import com.sslexplorer.core.CoreException;


/**
 * Validator for strings in a <i>boolean</i> format, i.e. true or false.
 * 
 * @author Brett Smith <a href="mailto: brett@3sp.com">&lt;brett@3sp.com&gt;</a>
 */
public class BooleanValidator implements PropertyValidator {

	public void validate(PropertyDefinition definition, String value, Properties properties) throws CodedException {
		String trueVal = "true";
		String falseVal = "false";
        if (definition.getTypeMetaObject() != null && !definition.getTypeMetaObject().equals("")) {
            trueVal = (String) (((List) definition.getTypeMetaObject()).get(0));
            falseVal = (String) (((List) definition.getTypeMetaObject()).get(1));
        }
        if(!trueVal.equals(value) && !falseVal.equals(value)) {

			throw new CoreException(ErrorConstants.ERR_INVALID_BOOLEAN,
							ErrorConstants.CATEGORY_NAME,
							ErrorConstants.BUNDLE_NAME,
							null,
							value,
							trueVal,
							falseVal,
							null);
        }
		
	}
}
