package com.sslexplorer.keystore;

import java.io.File;

import org.apache.struts.action.ActionForward;

import com.sslexplorer.core.FileDownload;

/**
 * <p>
 * Extension of {@link com.sslexplorer.core.FileDownload} for
 * downloading a CSR.
 * 
 * @author James D Robinson <a href="mailto:james@3sp.com">&lt;james@3sp.com&gt;</a>
 * 
 */
public class CSRDownload extends FileDownload {

    /**
     * @param file file
     * @param filename filename
     * @param mimeType The mimeType 
     * @param forward The forward to go to after the operation.
     * @param messageKey The message key
     * @param messageResourcesKey The message resource key.
     */
    public CSRDownload(File file, String filename, String mimeType, ActionForward forward, String messageKey,
                       String messageResourcesKey) {
        super(file, filename, mimeType, forward, messageKey, messageResourcesKey, null, null, null, null, null);
    }

    /**
     * @param file file
     * @param filename filename
     * @param mimeType The mimeType 
     * @param forward The forward to go to after the operation.
     * @param messageKey The message key
     * @param messageResourcesKey The message resource key.
     * @param messageArg1 The value for the first argument
     */
    public CSRDownload(File file, String filename, String mimeType, ActionForward forward, String messageKey,
                    String messageResourcesKey, String messageArg1) {
        super(file, filename, mimeType, forward, messageKey, messageResourcesKey, messageArg1, null, null, null, null);
    }
}
