package com.sslexplorer.language;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.sslexplorer.properties.Pair;
import com.sslexplorer.properties.PairListDataSource;

/**
 * Implementation of {@link PairListDataSource} that retrieves its data from
 * the list of installed language packs. This is currently used to select the
 * default language. 
 * 
 * @author Brett Smith <a href="mailto:brett@3sp.com">&lt;brett@3sp.com&gt;</a>
 */
public class LanguagePairListDataSource implements PairListDataSource {

    /* (non-Javadoc)
     * @see com.sslexplorer.properties.PairListDataSource#getValues(javax.servlet.http.HttpServletRequest)
     */
    public List getValues(HttpServletRequest request) {
        List<Pair> l = new ArrayList<Pair>();
        for(Iterator i = LanguagePackManager.getInstance().languages(); i.hasNext(); ) {
            Language lang  = (Language)i.next();
            l.add(new Pair(lang.getCode(), lang.getDescription()));
        }
        return l;
    }

}
