package com.sslexplorer.policyframework;

import java.util.Calendar;

import com.sslexplorer.realms.Realm;

public class DefaultPolicy extends AbstractResource implements Policy {

    private int type;
    private boolean addToFavorite = false;

    /**
     * Create a new empty policy of the specified type, ID and name.
     * @param realmID 
     * @param uniqueId policy id
     * @param name name of policy
     * @param description description
     * @param type type
     * @param dateCreated the date / time this policy was created
     * @param dateAmended the date / time this policy was last amended
     */
    public DefaultPolicy(int uniqueId, String name, String description, int type,
                    Calendar dateCreated, Calendar dateAmended, int realmID) {
        super(realmID, PolicyConstants.POLICY_RESOURCE_TYPE, uniqueId, name, description, dateCreated, dateAmended);
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.sslexplorer.policyframework.Policy#getType()
     */
    public int getType() {
        return type;
    }
    
    /* (non-Javadoc)
     * @see com.sslexplorer.policyframework.Policy#setType(int)
     */
    public void setType(int type) {
        this.type = type;
    }

    public boolean isAddToFavorite() {
        return addToFavorite;
    }

    public void setAddToFavorite(boolean addToFavorite) {
        this.addToFavorite = addToFavorite;
    }
}
