/*
 */
package com.sslexplorer.policyframework;

import java.util.List;

import javax.servlet.http.HttpServletRequest;

import com.sslexplorer.core.CoreUtil;
import com.sslexplorer.table.TableItem;

/**
 * 
 */
public class ResourceItem implements TableItem {

    private Resource resource;
    private List policies;
    private String checked;
    private String lastLaunchedPolicy;

    public ResourceItem(Resource resource, List policies) {
        this.resource = resource;
        this.policies = policies;
    }
    
    public String getLastLaunchedPolicy() {
    	return lastLaunchedPolicy;
    }
    
    public boolean getMultiplePolicies() {
        return policies.size() > 1;
    }
    
    public String getFirstPolicyName() {
        return policies.size() > 0 ? ((Policy)policies.get(0)).getResourceName() : ""; 
    }
    
    public List getPolicies() {
        return policies;
    }

    public Resource getResource() {
        return resource;
    }

    public Object getColumnValue(int col) {
        return resource.getResourceName() == null ? "<Unknown>" : resource.getResourceName();
    }

    public void setChecked(String checked) {
        this.checked = checked;        
    }

    public String getChecked() {
        return checked;        
    }

    public String getSmallIconPath(HttpServletRequest request) {
        return CoreUtil.getThemePath(request.getSession()) + "/images/actions/resource.gif";
    }

    public String getLargeIconPath(HttpServletRequest request) {
        return CoreUtil.getThemePath(request.getSession()) + "/images/actions/largeResource.gif";
    }

    public String getLargeIconAdditionalIcon(HttpServletRequest request) {
        return "";
    }

    public String getLargeIconAdditionalText(HttpServletRequest request) {
        return "";
    }

    public String getLink(int policy, HttpServletRequest request) {
    	return getLink(policy, null, request);
    }

    public String getLink(int policy, String referer, HttpServletRequest request) {
    	return "#";
    }

    public String getOnClick(int policy, HttpServletRequest request) {
    	return "";
    }

}
