package com.sslexplorer.policyframework.forms;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionMapping;

import com.sslexplorer.boot.PropertyList;
import com.sslexplorer.input.MultiSelectSelectionModel;
import com.sslexplorer.policyframework.AccessRight;
import com.sslexplorer.policyframework.AccessRights;
import com.sslexplorer.policyframework.Permission;
import com.sslexplorer.policyframework.PolicyDatabaseFactory;
import com.sslexplorer.policyframework.Resource;
import com.sslexplorer.policyframework.ResourceType;
import com.sslexplorer.security.SessionInfo;
import com.sslexplorer.security.User;
import com.sslexplorer.tabs.TabModel;

public class AccessRightsForm extends AbstractResourceForm implements TabModel {
    
    final static Log log = LogFactory.getLog(PoliciesForm.class);

    private int selectedResourceTypeId;
    private List resourceTypes;
    private ResourceType resourceType;
    private String[] selectedAvailablePermissions;
    private List resourceTypePermissions;
    private String[] selectedResourceTypePermissions;
    private List availablePermissions;
    private String selectedTab = "details";

    public AccessRightsForm() {
        super();
    }

    public int getSelectedResourceType() {
        return selectedResourceTypeId;
    }

    public void setSelectedResourceType(int resourceType) {
        this.selectedResourceTypeId = resourceType;
    }

    public int getTabCount() {
        return 3;
    }

    public String getTabName(int idx) {
        switch(idx) {
            case 0:
                return "details";
            case 1:
                return "permissions";
            default:
                return "policies";
        }
    }

    public String getTabTitle(int idx) {
        return null;
    }

    public void initialise(User user, Resource resource, boolean editing, MultiSelectSelectionModel policyModel, PropertyList selectedPolicies, User owner, boolean assignOnly) throws Exception {
        super.initialise(user, resource, editing, policyModel, selectedPolicies, owner, assignOnly);
        rebuild();
    }
    
    public void rebuild() throws Exception {
        selectedAvailablePermissions = new String[0];
        AccessRights dr = (AccessRights)resource;
        List r = PolicyDatabaseFactory.getInstance().getResourceTypes(dr.getAccessRightsClass());
        resourceTypes = new ArrayList();
        for(Iterator i = r.iterator(); i.hasNext(); ) {
            ResourceType rt = (ResourceType)i.next();
            if(rt.getPermissions().size() > 0 ) {
                resourceTypes.add(rt);
            }
        }
        resourceTypePermissions = dr.getAccessRights();
        resourceTypes = new ArrayList();
        availablePermissions = new ArrayList();
        resourceTypes = PolicyDatabaseFactory.getInstance().getResourceTypes(dr.getAccessRightsClass());
        if(resourceType == null) {
            resourceType = (ResourceType)resourceTypes.get(0);
            selectedResourceTypeId = resourceType.getResourceTypeId();
        }
        availablePermissions = new ArrayList();
        for(Iterator i = resourceType.getPermissions().iterator(); i.hasNext(); ) {
            Permission perm = (Permission)i.next();
            AccessRight rt = new AccessRight(resourceType, perm);
            if(!resourceTypePermissions.contains(rt)) {
                availablePermissions.add(perm);
            }
        }
    }

    public List getAvailablePermissions() {
        return availablePermissions;
    }

    public void setAvailablePermissions(List availablePermissions) {
        this.availablePermissions = availablePermissions;
    }

    public ResourceType getResourceType() {
        return resourceType;
    }

    public void setResourceType(ResourceType resourceType) {
        this.resourceType = resourceType;
    }

    public List getResourceTypePermissions() {
        return resourceTypePermissions;
    }

    public void setResourceTypePermissions(List resourceTypePermissions) {
        this.resourceTypePermissions = resourceTypePermissions;
    }

    public List getResourceTypes() {
        return resourceTypes;
    }

    public void setResourceTypes(List resourceTypes) {
        this.resourceTypes = resourceTypes;
    }

    public String[] getSelectedAvailablePermissions() {
        return selectedAvailablePermissions;
    }

    public void setSelectedAvailablePermissions(String[] selectedAvailablePermissions) {
        this.selectedAvailablePermissions = selectedAvailablePermissions;
    }

    public int getSelectedResourceTypeId() {
        return selectedResourceTypeId;
    }

    public void setSelectedResourceTypeId(int selectedResourceTypeId) {
        this.selectedResourceTypeId = selectedResourceTypeId;
    }

    public String[] getSelectedResourceTypePermissions() {
        return selectedResourceTypePermissions;
    }

    public void setSelectedResourceTypePermissions(String[] selectedResourceTypePermissions) {
        this.selectedResourceTypePermissions = selectedResourceTypePermissions;
    }
    
    public Resource getResourceByName(String name, SessionInfo session) throws Exception {
        return PolicyDatabaseFactory.getInstance().getAccessRightsByName(name, session.getUser().getRealm().getRealmID());
    }
    
    public String getSelectedTab() {
        return selectedTab;
    }
    
    public void setSelectedTab(String selectedTab) {
        this.selectedTab = selectedTab;        
    }
    
    public void applyToResource() {    
    }


    public void reset(ActionMapping mapping, HttpServletRequest request) {
        super.reset(mapping, request);
    }
    
    /* (non-Javadoc)
     * @see com.sslexplorer.tabs.TabModel#getTabBundle(int)
     */
    public String getTabBundle(int idx) {
        return null;
    }
}
