/*
 *  SSL-Explorer
 *
 *  Copyright (C) 2003-2006 3SP LTD. All Rights Reserved
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
			
package com.sslexplorer.policyframework.forms;

import java.util.List;

import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.sslexplorer.policyframework.ResourceItemModel;

public class AccessRightsListForm extends AbstractResourcesForm {

    final static Log log = LogFactory.getLog(AccessRightsListForm.class);

    public AccessRightsListForm() {
        super(new AccessRightsModel());
    }

    public void initialize(List resources, Class resourceItemClass, HttpSession session) {
        super.initialize(resources, resourceItemClass, session, "name");
    }

    static class AccessRightsModel extends ResourceItemModel {
        public AccessRightsModel() {
            super("accessRights");
        }

        public int getColumnCount() {
            return 3;
        }

        public String getColumnName(int col) {
            if (col == 2) {
                return "permissionClass";
            } 
            return super.getColumnName(col);
        }

        public int getColumnWidth(int col) {
            return 0;
        }
    }

    static class PermittingAccessRightsModel extends ResourceItemModel {
        public PermittingAccessRightsModel() {
            super("permittingResourcePermissions");
        }

        public int getColumnCount() {
            return 3;
        }

        public String getColumnName(int col) {
            if (col == 2) {
                return "permissionClass";
            }
            return super.getColumnName(col);
        }

        public int getColumnWidth(int col) {
            return 0;
        }
    }
}