/**
 * 
 */
package com.sslexplorer.policyframework.itemactions;

import org.apache.struts.action.ActionMapping;

import com.sslexplorer.navigation.AbstractFavoriteItem;
import com.sslexplorer.policyframework.NoPermissionException;
import com.sslexplorer.policyframework.PolicyConstants;
import com.sslexplorer.policyframework.PolicyUtil;
import com.sslexplorer.policyframework.ResourceItem;
import com.sslexplorer.security.Constants;
import com.sslexplorer.security.SessionInfo;
import com.sslexplorer.table.AvailableTableItemAction;
import com.sslexplorer.table.TableItemAction;

public final class RemoveFromFavoritesAction extends AbstractPathAction {
    
    public static final String TABLE_ITEM_ACTION_ID = "removeFromFavorites";

	public RemoveFromFavoritesAction(String messageResourcesKey) {
		super(TABLE_ITEM_ACTION_ID, messageResourcesKey, 100, false, SessionInfo.USER_CONSOLE_CONTEXT, 
	        "{2}.do?actionTarget=removeFavorite&selectedResource={0}");
	}

    public boolean isEnabled(AvailableTableItemAction availableItem) {
        AbstractFavoriteItem item = (AbstractFavoriteItem) availableItem.getRowItem();
        if(item.getFavoriteType().equals(AbstractFavoriteItem.USER_FAVORITE)) {
            try {
                PolicyUtil.checkPermission(PolicyConstants.FAVORITES_RESOURCE_TYPE, PolicyConstants.PERM_USE, availableItem.getRequest());
                return true;
            } catch (NoPermissionException npe) {
            }
        }
        return false;
    }
}