package com.sslexplorer.properties.attributes.forms;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.util.MessageResources;

import com.sslexplorer.core.forms.CoreForm;
import com.sslexplorer.extensions.ExtensionBundle;
import com.sslexplorer.properties.attributes.AttributeDefinition;

public class AttributeDefinitionInformationForm extends CoreForm {
    final static Log log = LogFactory.getLog(AttributeDefinitionInformationForm.class);
    
    private AttributeDefinition definition;
    private String categoryLabel, label, description;
    
    public void initialise(MessageResources messageResources, AttributeDefinition definition) {
    	this.definition = definition;
        String s = messageResources == null ? null : messageResources.getMessage("attributeCategory." + definition.getCategory() + ".title");
        if (s != null && !s.equals("")) {
            categoryLabel = s;
        } else {
            categoryLabel = definition.getCategoryLabel() != null && !definition.getCategoryLabel().equals("") ? definition.getCategoryLabel() : "Attributes";
        }
        s = messageResources == null ? null : messageResources.getMessage("attribute." + definition.getName() + ".title");
        if (s != null && !s.equals("")) {
            label = s;
        } else {
            label = definition.getLabel() != null && !definition.getLabel().equals("") ? definition.getLabel() : definition.getName();
        }
        s = messageResources == null ? null : messageResources.getMessage("attribute." + definition.getName() + ".description");
        if (s != null && !s.equals("")) {
            description = s;
        } else {
            description = definition.getDescription() != null && !definition.getDescription().equals("") ? definition.getDescription() : label;
        }
    }
    
    public AttributeDefinition getDefinition() {
    	return definition;
    }

	public String getCategoryLabel() {
		return categoryLabel;
	}

	public String getDescription() {
		return description;
	}

	public String getLabel() {
		return label;
	}
}
