package com.sslexplorer.realms;

import java.io.Serializable;
import java.util.Calendar;

import com.sslexplorer.policyframework.AbstractResource;
import com.sslexplorer.policyframework.PolicyConstants;
import com.sslexplorer.security.UserDatabase;

/**
 * Default implementation of a
 * {@link com.sslexplorer.properties.PropertyProfile}.
 * 
 * @author James D Robinson <a href="mailto:james@3sp.com">&lt;james@3sp.com&gt;</a>
 *
 */
public class DefaultRealm extends AbstractResource implements Realm, Serializable {

    
    private UserDatabase userDatabase;
    private String type;
    private boolean hasUserDatabase = false;
    
    /**
     * @param type
     * @param resourceId
     * @param resourceName
     * @param resourceDescription
     * @param dateCreated
     * @param dateAmended
     */
    public DefaultRealm(String type, int resourceId, String resourceName, String resourceDescription, Calendar dateCreated, Calendar dateAmended) {
        // note the realm id and the resourtce id are the same.
        super(resourceId, PolicyConstants.REALMS_RESOURCE_TYPE, resourceId, resourceName, resourceDescription, dateCreated, dateAmended);
        this.type = type;
    }

    /* (non-Javadoc)
     * @see com.sslexplorer.realms.Realm#getType()
     */
    public String getType() {
        return type;
    }

    /* (non-Javadoc)
     * @see com.sslexplorer.realms.Realm#setType(java.lang.String)
     */
    public void setType(String type) {
        this.type = type;
    }

    public boolean isHasUserDatabase() {
        return hasUserDatabase;
    }
}
