/*
 *  SSL-Explorer
 *
 *  Copyright (C) 2003-2006 3SP LTD. All Rights Reserved
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
			
package com.sslexplorer.security;

import com.sslexplorer.policyframework.Principal;


/**
 * A role represents a collection of users and is a {@link com.sslexplorer.policyframework.Principal} 
 * in its own right.
 * <p>
 * <b>NOTE, Role is no more properly known as a <i>Group</i>. The name
 * Role is a hangup from SSL-Explorer pre 0.2.0.</b>
 * 
 * TODO Rename this to Group
 * 
 * @author Brett Smith <a href="mailto: brett@3sp.com">&lt;brett@3sp.com&gt;</a>
 * @param <T>
 */
public interface Role<T> extends Principal, Comparable<T> {
}
