/*
 *  SSL-Explorer
 *
 *  Copyright (C) 2003-2006 3SP LTD. All Rights Reserved
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
			
package com.sslexplorer.security;

import com.sslexplorer.table.AbstractTableItemTableModel;

/**
 * Extension of {@link com.sslexplorer.table.AbstractTableItemTableModel}
 * to be used for display lists of users (i.e. {@link com.sslexplorer.security.UserItem}
 * objects).
 * 
 * @author Brett Smith <a href="mailto: brett@3sp.com">&lt;brett@3sp.com&gt;</a>
 */
public class UserItemModel extends AbstractTableItemTableModel {

    /* (non-Javadoc)
     * @see com.sslexplorer.table.TableModel#getColumnCount()
     */
    public int getColumnCount() {
        return 5;
    }

    /* (non-Javadoc)
     * @see com.sslexplorer.table.TableModel#getColumnName(int)
     */
    public String getColumnName(int col) {
        switch (col) {
            case 0:
                return "status";
            case 1:
                return "account";
            case 2:
                return "name";
            case 3:
                return "administrator";
            case 4:
                return "mark";
        }
        return null;
    }

    /* (non-Javadoc)
     * @see com.sslexplorer.table.TableModel#getColumnClass(int)
     */
    public Class getColumnClass(int col) {
        switch (col) {
            case 0:
                return Integer.class;
            case 3:
                return Boolean.class;
            case 4:
                return Boolean.class;
        }
        return String.class;
    }

    /* (non-Javadoc)
     * @see com.sslexplorer.table.AbstractTableItemTableModel#getColumnWidth(int)
     */
    public int getColumnWidth(int col) {
        return 0;
    }

    /* (non-Javadoc)
     * @see com.sslexplorer.table.TableItemModel#getId()
     */
    public String getId() {
        return "accounts";
    }

}