/*
 *  SSL-Explorer
 *
 *  Copyright (C) 2003-2006 3SP LTD. All Rights Reserved
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
			
package com.sslexplorer.security.forms;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.apache.struts.action.ActionMapping;

import com.sslexplorer.security.User;
import com.sslexplorer.security.UserItem;
import com.sslexplorer.security.UserItemModel;
import com.sslexplorer.table.forms.AbstractPagerForm;

public class ShowAvailableAccountsForm extends AbstractPagerForm {

    boolean isEditable;
    boolean errored;

    static Log log = LogFactory.getLog(ShowAvailableAccountsForm.class);

    public ShowAvailableAccountsForm() {
        super(new UserItemModel());
    }

    public void initialize(User[] users, User currentUser, HttpSession session) {
        super.initialize(session, "account");
        for (int i = 0; users != null && i < users.length; i++) {
            UserItem item = new UserItem(users[i]);
            getModel().addItem(item);
        }
        getPager().rebuild(getFilterText());
    }

    public String getEditable() {
        return String.valueOf(isEditable);
    }

    public void setEditable(boolean isEditable) {
        this.isEditable = isEditable;
    }

    public void setErrored(boolean errored) {
        this.errored = errored;        
    }
    
    public boolean getErrored() {
        return errored;
    }

    /* (non-Javadoc)
     * @see com.sslexplorer.table.forms.AbstractPagerForm#reset(org.apache.struts.action.ActionMapping, javax.servlet.http.HttpServletRequest)
     */
    public void reset(ActionMapping mapping, HttpServletRequest request) {
        super.reset(mapping, request);
        errored = false;
    }

}