/*
 *  SSL-Explorer
 *
 *  Copyright (C) 2003-2006 3SP LTD. All Rights Reserved
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
			
package com.sslexplorer.setup.forms;

import java.util.Iterator;
import java.util.Map;

import javax.servlet.http.HttpSession;

import com.sslexplorer.security.LogonControllerFactory;
import com.sslexplorer.security.SessionInfo;
import com.sslexplorer.setup.ActiveSession;
import com.sslexplorer.setup.UserSessionsTableModel;
import com.sslexplorer.table.forms.AbstractPagerForm;


/**
 * Implementation of a {@link AbstractPagerForm} that is used to display various
 * status details.
 * <p>
 * This form 
 * 
 * @author Brett Smith <a href="mailto: brett@3sp.com">&lt;brett@3sp.com&gt;</a>
 */
public class UserSessionsForm extends AbstractPagerForm {

    /**
     * Constructor.
     *
     */
    public UserSessionsForm() {
        super(new UserSessionsTableModel());
    }
    
    /**
     * Initialise
     * 
     * @param session session
     */
    public void initialize(HttpSession session) {
        super.initialize(session, "user");
        Map active = LogonControllerFactory.getInstance().getActiveSessions();
        for (Iterator i = active.entrySet().iterator(); i.hasNext();) {
            Map.Entry entry = (Map.Entry) i.next();
            String ticket = (String) entry.getKey();
            SessionInfo info = (SessionInfo) entry.getValue();
            ActiveSession activeSession = new ActiveSession(info);
            getModel().addItem(activeSession);
        }
        getPager().rebuild(getFilterText());
    }
}