package com.sslexplorer.tasks.shutdown;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.TimerTask;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.sslexplorer.boot.ContextHolder;

public class ShutdownTimerTask extends TimerTask {

	final static Log log = LogFactory.getLog(ShutdownTimerTask.class);

	public static String NAME = "shutdown.task";
	
	boolean restart = false;
	long defaultDelay = 10000;
	long delay = 0;
	
	public ShutdownTimerTask(boolean restart, int delayInMins) {
		super();
		this.restart = restart;
		this.delay = (delayInMins*60*1000) ;
	}

	public void run() {
		if (log.isInfoEnabled())
			log.info("About to perform shutdown task.");
        ContextHolder.getContext().shutdown(restart);
	}

	public long getDelay() {
		// this is so the minimum shutdown time is 10 seconds.
		if (delay < defaultDelay)
			return defaultDelay;
		else
			return delay;
	}

	public void setDelay(long shutdownTime) {
		this.delay = shutdownTime;
	}

	public Date getShutDownTime(){
	    return new Date(System.currentTimeMillis() +this.getDelay());
	}
	
	public String getShutDownTimeString(){
		return getShutDownTimeString("HH:mm");
	}

	public String getShutDownTimeString(String pattern){
		SimpleDateFormat sdf = new SimpleDateFormat(pattern);
	    return sdf.format(getShutDownTime());
	}
	
}
