/*
 *  SSL-Explorer
 *
 *  Copyright (C) 2003-2006 3SP LTD. All Rights Reserved
 *
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public
 *  License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */
			
package com.sslexplorer.vfs.webdav;

import java.io.IOException;

/**
 * @author Brett Smith <brett@3sp.com>
 */
public class DAVAuthenticationRequiredException extends IOException {
   
    private static final long serialVersionUID = 6441564703419942759L;
    private String httpRealm;
    private boolean hasCredentials;

    /**
     * @param httpRealm The httpRealm
     * @param hasCredentials has credentials
     * 
     */
    public DAVAuthenticationRequiredException(String httpRealm, boolean hasCredentials) {
        super("Authentication Required.");
        this.httpRealm = httpRealm;
        this.hasCredentials = hasCredentials;
    }   
    
    /**
     * @return String for the httpRealm
     */
    public String getHttpRealm() {
        return httpRealm;
    }
    
    /**
     * @return has credentials
     */
    public boolean hasCredentials() {
    	return hasCredentials;
    }
}
