/*
 */
package com.sslexplorer.vfs.webdav;

import java.util.HashMap;

public class DAVSession {
  private HashMap attributes;
  private String id;
  
  public static final String ATTR_AUTH_PAIRS = "authPairs";
  public static final String ATTR_RESOURCE_PATH = "resourcePath";
  public static final String ATTR_USER = "user";
  public static final String ATTR_REQUEST_METHOD = "requestMethod";
  public static final String ATTR_NODE_CACHE = "nodeCache";
  public static final String ATTR_PROFILE = "profile";
  public static final String ATTR_EXTRACT = "extract";
  public static final String ATTR_ACCEPT_TYPES = "acceptTypes";
  
  public DAVSession(String id) {
    this.id = id;
    attributes = new HashMap();
  }
  
  public String getId() {
    return id;
  }
  
  public Object getAttribute(String name) {
    return attributes.get(name);
  }
  
  public void setAttribute(String name, Object value) {
    attributes.put(name, value);
  }
  
  public void removeAttribute(String name) {
    attributes.remove(name);
  }
}
